#include "glpk_wrapper.h"

#define VARI_NUM 4
#define CONS_NUM 2

int main(void) {
  Matrix mat(CONS_NUM) ;
  for (unsigned i = 0; i < CONS_NUM; ++ i) {
    mat[i].resize(VARI_NUM+1) ;
  }
  mat[0][0] = -1 ; mat[0][1] = 0 ; mat[0][2] = 1 ; mat[0][3] = 0 ; mat[0][4] = -1 ;
  mat[1][0] = 0 ; mat[1][1] = -1 ; mat[1][2] = 0 ; mat[1][3] = 1 ; mat[1][4] = -1 ;

  GlpkInterface glpk_inter ;
  glpk_inter.AddRows(mat) ;
  std::vector<unsigned> irrd_idx ;
  RowVector curr_vec ;
  Matrix curr_mat(1) ;
  for (unsigned i = 0; i < CONS_NUM; ++ i) {
    curr_vec = mat[i] ;
    glpk_inter.SwapRows(i, CONS_NUM-1) ;
    glpk_inter.DeleteRowBack() ;

    RowVector obj(VARI_NUM) ;
    /*
    std::vector<unsigned> ch_order = GetSubProbCoef(dimension_, ineq_.GetRow(i)) ; 
    for (unsigned j = 0; j < dimension_; ++ j) {
      obj[j] = ineq_.Get(i, j).GetUpperBound() ;
      obj[j+dimension_] = - ineq_.Get(i, j).GetUpperBound() ;
    }
    bool irre ;
    int k = -1 ;
    do {
      irre = true ;
      ++ k ;
      */
      glpk_inter.SetObj(obj) ;
      glpk_inter.Simplex() ;

      /*
      ResultState res_state = glpk_inter.VerifiedFloatOptimal(true, false) ;
      if (res_state != ResultState::UnknownFsb && 
          res_state != ResultState::GlpkFail) {
        //if (res_state == ResultState::VerifiedUbd) {
        //  std::cout << "verify unbound" << std::endl ;
        //}
        // if res_state == ResultState::UnknownOpt 
        // or res_state == ResultState::UnknownUbd
        //else {
        if (res_state != ResultState::VerifiedUbd) {
          std::vector<Interval> x_opt_val = glpk_inter.GetVariVecVal() ;
          IntervalObj itv_op ;
          Interval sum(0, 0), curr_val, curr_mul ;
          for (unsigned j = 0; j < dimension_; ++ j) {
            curr_val = itv_op.IntervalsSub(x_opt_val[j], x_opt_val[dimension_+j]) ;
            curr_mul = itv_op.IntervalsMul(curr_val, ineq_.Get(i, j)) ;
            sum = itv_op.IntervalsAdd(sum, curr_mul) ;
          }
          if (-sum.GetLowerBound() <= ineq_.Get(i, dimension_).GetUpperBound()) {
            irre = false ;
            break ;
          }
        }
      }
      // impossible, as we have checked empty interior
      else {
        return false ;
      }
      */

      /*
      if (k < (int)ch_order.size()) {
        if (obj[ch_order[k]] == ineq_.Get(i, ch_order[k]).GetUpperBound()) {
          obj[ch_order[k]] = - ineq_.Get(i, ch_order[k]).GetLowerBound() ;
        }
        else {
          obj[ch_order[k]] = ineq_.Get(i, ch_order[k]).GetUpperBound() ;
        }
        obj[dimension_+ch_order[k]] = - obj[ch_order[k]] ;
      }
    } while (k < (int)ch_order.size()) ;
    if (irre) {
      irrd_idx.push_back(i) ;
    }
    */
    curr_mat[0] = curr_vec ;
    glpk_inter.AddRows(curr_mat) ;
    glpk_inter.SwapRows(i, CONS_NUM-1) ;
  }
  /*
  IntervalMatrix tmp_mat = ineq_ ;
  ineq_.Clear() ;
  ineq_.AddRows(std::move(tmp_mat), irrd_idx) ;
  return true ;
  */

}
